/*   Elantech Passthrough Support
 *   Copyright (c) 2008 Elantech Inc Tom Lin<tom_lin@elantech.com.tw>
 *   Copyring  (c) 2009 ELAN Inc Tom Lin<tom_lin@emc.com.tw>
 *   					   Roger Chaung <roger_chaung@emc.com.tw>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 * Trademarks are the property of their respective owners.
 *
 */
#include "QElanTrayicon.h"



void QElanTrayicon::createTrayIconMenu()
{
	trayIconMenu = new QMenu();
	trayIconMenu->addAction(property_of_smart_pad);
	trayIcon->setContextMenu(trayIconMenu);

}

void QElanTrayicon::slot_iconActivated(QSystemTrayIcon::ActivationReason reason)
{
	switch(reason){
		case QSystemTrayIcon::Trigger:
			system("/usr/local/bin/Qtelantech &");
			break;
		default:
			break;
	}
	

}

void QElanTrayicon::createActions()
{
	property_of_smart_pad = new QAction(tr("Property of Smart-Pad"),this);
	connect(property_of_smart_pad,SIGNAL(triggered()),this,SLOT(slot_property_of_smart_pad()));
}


void QElanTrayicon::slot_property_of_smart_pad()
{
	system("/usr/local/bin/Qtelantech &");
	return;

}



	 QElanTrayicon::QElanTrayicon()
{
		QIcon icon = QIcon("/usr/share/elantouchpad_data/pixmaps/ElanIcon_middle.bmp");
		trayIcon = new QSystemTrayIcon();
		trayIcon->setIcon(icon);
		trayIcon->setToolTip("Elan Smart-Pad");	
		createActions();
		createTrayIconMenu();
		trayIcon->show();
		//cout << "step_4 TrayIcon setting OK" << endl;
		connect(trayIcon,SIGNAL(activated(QSystemTrayIcon::ActivationReason)),this,SLOT(slot_iconActivated(QSystemTrayIcon::ActivationReason)));
}
