#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "debug_elan.h"


typedef struct {

	/*page General*/
	int	SHM_touch_checkBox;
	double	SHM_maxspeed_slider; 

	/*page Button*/
	int	SHM_button_checkBox;
	int	SHM_button_left_comboBox;
	int	SHM_button_middle_comboBox;
	int	SHM_button_right_comboBox;
	
	/*page Tapping*/
	int	SHM_tapping_checkBox;
	int	SHM_two_FT_comboBox;
	int	SHM_three_FT_comboBox;
	int	SHM_disable_when_key_checkBox;
	int	SHM_tapping_delay_comboBox;
	int	SHM_cursor_delay_comboBox;
	int	SHM_gesture_delay_comboBox;
	int	SHM_cover_delay_comboBox;
	int	SHM_palmtrack_delay_comboBox;

	/*page Edge Scroll*/
	int	SHM_edge_v_scroll_checkBox;
	int	SHM_edge_h_scroll_checkBox;
	int	SHM_edge_scroll_speed_slider;
	int	SHM_edge_scroll_area_slider;


	/*page Scrolling*/
	int	SHM_vertical_scrolling_checkBox;
	int	SHM_horizontal_scrolling_checkBox;
	int	SHM_scrolling_speed_slider;	
	int	SHM_auto_scroll_checkBox;

	/*page Zoom*/
	int	SHM_zoom_checkBox;
	int	SHM_zoom_out_comboBox;
	int	SHM_zoom_in_comboBox;
	int 	SHM_zoom_slider;

	/*page Rotation*/
	int	SHM_rotation_checkBox;
	int 	SHM_clockwise_comboBox;
	int	SHM_counterclosewise_comboBox;
	int	SHM_rotation_slider;
	
	/*page Drag*/
	int	SHM_drag_checkBox;
	int	SHM_lift_release_radioButton;
	int	SHM_tap_again_radioButton;
	int	SHM_tap_release_radioButton;
	double  SHM_drag_slider;
	
	/*page Swipe*/
	int	SHM_swipe_page_checkBox;
	
	/*page Fast_keys*/
	int	SHM_fast_key_checkBox;
	int	SHM_my_home_file_checkBox;
	int	SHM_switch_windows_checkBox;

	/*page Covergesture*/
	int	SHM_covergesture_checkBox;
	int	SHM_covergesture_slider;
	int	SHM_covergesture_comboBox;

	/*page_10 PalmTracking*/
	int	SHM_palmtracking_checkBox;
	int	SHM_palmtracking_slider;	
} Elashm;

int main()
{
	Elashm cur_elanshm;
	FILE *fp0,*fp1;
	int  file_over,count=0,cmp;
	int  error_sys;
	int  value;
	float value_d;
	char *command = (char *)malloc(128*sizeof(char));
	char str[128];
	char *str1 = (char *) malloc (strlen("Parameter")*sizeof(char));
	char *str2 = (char *) malloc (strlen("settings:")*sizeof(char));
	char *str_TouchpadOff = (char *) malloc (21*sizeof(char));//TouchpadOff=
	char *str_MaxSpeed = (char *) malloc (strlen("MaxSpeed=")*sizeof(char));
	char *str_ButtonCheckBox = (char *) malloc (strlen("ButtonCheckBox=")*sizeof(char));
	char *str_ButtonLeftComboBox = (char *) malloc (strlen("ButtonLeftComboBox=")*sizeof(char));
	char *str_ButtonMiddleComboBox = (char *) malloc (strlen("ButtonMiddleComboBox=")*sizeof(char));
	char *str_ButtonRightComboBox = (char *) malloc (strlen("ButtonMiddleComboBox=")*sizeof(char));
	char *str_TappingCheckBox = (char *) malloc (strlen("TappingCheckBox=")*sizeof(char));
	char *str_TwoFTComboBox = (char *) malloc (strlen("TwoFTComboBox=")*sizeof(char));
	char *str_ThreeFTComboBox = (char *) malloc (strlen("ThreeFTComboBox=")*sizeof(char));
	char *str_DisableWhenKeyCheckBox = (char *) malloc (strlen("DisableWhenKeyCheckBox=")*sizeof(char));
	char *str_TappingDelayComboBox = (char *) malloc (strlen("TappingDelayComboBox=")*sizeof(char));
	char *str_CursorDelayComboBox = (char *) malloc (21*sizeof(char));//CursorDelayComboBox=
	char *str_GestureDelayComboBox = (char *) malloc (strlen("GestureDelayComboBox=")*sizeof(char));
	char *str_CoverDelayComboBox = (char *) malloc (strlen("CoverDelayComboBox=")*sizeof(char));
	char *str_PalmtrackDelayComboBox = (char *) malloc (strlen("PalmtrackDelayComboBox=")*sizeof(char));
	char *str_EdgeVscrollCheckBox = (char *) malloc (21*sizeof(char));//EdgeVscrollCheckBox=
	char *str_EdgeHscrollCheckBox = (char *) malloc (21*sizeof(char));//EdgeHscrollCheckBox
	char *str_EdgeScrollSpeedSlider = (char *) malloc (strlen("EdgeScrollSpeedSlider=")*sizeof(char));
	char *str_EdgeScrollAreaSlider = (char *) malloc (strlen("EdgeScrollAreaSlider=")*sizeof(char));
	char *str_VerticalScrollingCheckBox = (char *) malloc (strlen("VerticalScrollingCheckBox=")*sizeof(char));
	char *str_HorizontalScrollingCheckBox = (char *) malloc (30*sizeof(char));//HorizontalScrollingCheckBox=
	char *str_ScrollingSpeedSlider = (char *) malloc (strlen("ScrollingSpeedSlider=")*sizeof(char));
	char *str_AutoScrollCheckBox = (char *) malloc (strlen("AutoScrollCheckBox=")*sizeof(char));
	char *str_ZoomCheckBox = (char *) malloc (strlen("ZoomCheckBox=")*sizeof(char));
	char *str_ZoomOutComboBox = (char *) malloc (strlen("ZoomOutComboBox=")*sizeof(char));
	char *str_ZoomInComboBox = (char *) malloc (strlen("ZoomInComboBox=")*sizeof(char));
	char *str_ZoomSlider = (char *) malloc (strlen("ZoomSlider=")*sizeof(char));
	char *str_RotationCheckBox = (char *) malloc (strlen("RotationCheckBox=")*sizeof(char));
	char *str_ClockwiseComboBox = (char *) malloc (strlen("ClockwiseComboBox=")*sizeof(char));
	char *str_CounterclosewiseComboBox = (char *) malloc (strlen("CounterclosewiseComboBox=")*sizeof(char));
	char *str_RotationSlider = (char *) malloc (strlen("RotationSlider=")*sizeof(char));
	char *str_DragCheckBox = (char *) malloc (strlen("DragCheckBox=")*sizeof(char));
 	char *str_LiftReleaseRadioButton = malloc (strlen("LiftReleaseRadioButton=")*sizeof(char));
	char *str_TapAgainRadioButton = (char *) malloc (21*sizeof(char));//TapAgainRadioButton=
	char *str_TapReleaseRadioButton = (char *) malloc(strlen("TapReleaseRadioButton=")*sizeof(char));
	char *str_DragSlider = (char *) malloc(strlen("DragSlider=")*sizeof(char));
	char *str_SwipePageCheckBox = (char *) malloc (strlen("SwipePageCheckBox=")*sizeof(char));
	char *str_FastKeyCheckBox = (char *) malloc (strlen("FastKeyCheckBox=")*sizeof(char));
	char *str_MyHomeFileCheckBox = (char *) malloc (strlen("MyHomeFileCheckBox=")*sizeof(char));
	char *str_SwitchWindowsCheckBox = (char *) malloc (strlen("SwitchWindowsCheckBox=")*sizeof(char));
	char *str_CovergestureCheckBox = (char *) malloc (strlen("CovergestureCheckBox=")*sizeof(char));
	char *str_CovergestureSlider = (char *) malloc (21*sizeof(char));//CovergestureSlider
	char *str_CovergestureComboBox = (char *) malloc (strlen("CovergestureComboBox=")*sizeof(char));
	char *str_PalmtrackingCheckBox = (char *) malloc (21*sizeof(char));//PalmtrackingCheckBox
	char *str_PalmTrackingSlider = (char *) malloc (strlen("PalmTrackingSlider=")*sizeof(char));
	char *str_NULL = NULL;
	
	strcpy(str1, "Parameter");
	strcpy(str2, "settings:");
	strcpy(str_TouchpadOff, "TouchpadOff=");
	strcpy(str_MaxSpeed, "MaxSpeed=");
	strcpy(str_ButtonCheckBox, "ButtonCheckBox=");
	strcpy(str_ButtonLeftComboBox, "ButtonLeftComboBox=");
	strcpy(str_ButtonMiddleComboBox, "ButtonMiddleComboBox=");
	strcpy(str_ButtonRightComboBox, "ButtonRightComboBox=");
	strcpy(str_TappingCheckBox, "TappingCheckBox=");
	strcpy(str_TwoFTComboBox, "TwoFTComboBox=");
	strcpy(str_ThreeFTComboBox, "ThreeFTComboBox=");
	strcpy(str_DisableWhenKeyCheckBox, "DisableWhenKeyCheckBox=");
	strcpy(str_TappingDelayComboBox, "TappingDelayComboBox=");
	strcpy(str_CursorDelayComboBox, "CursorDelayComboBox=");
	strcpy(str_GestureDelayComboBox, "GestureDelayComboBox=");
	strcpy(str_CoverDelayComboBox, "CoverDelayComboBox=");
	strcpy(str_PalmtrackDelayComboBox, "PalmtrackDelayComboBox=");
	strcpy(str_EdgeVscrollCheckBox, "EdgeVscrollCheckBox=");
	strcpy(str_EdgeHscrollCheckBox, "EdgeHscrollCheckBox=");
	strcpy(str_EdgeScrollSpeedSlider,"EdgeScrollSpeedSlider=");
	strcpy(str_EdgeScrollAreaSlider,"EdgeScrollAreaSlider=");
	strcpy(str_VerticalScrollingCheckBox, "VerticalScrollingCheckBox=");
	strcpy(str_HorizontalScrollingCheckBox, "HorizontalScrollingCheckBox=");
	strcpy(str_ScrollingSpeedSlider, "ScrollingSpeedSlider=");
	strcpy(str_AutoScrollCheckBox, "AutoScrollCheckBox=");
	strcpy(str_ZoomCheckBox, "ZoomCheckBox=");
	strcpy(str_ZoomOutComboBox, "ZoomOutComboBox=");
	strcpy(str_ZoomInComboBox, "ZoomInComboBox=");
	strcpy(str_ZoomSlider, "ZoomSlider=");
	strcpy(str_RotationCheckBox, "RotationCheckBox=");
	strcpy(str_ClockwiseComboBox, "ClockwiseComboBox=");
	strcpy(str_CounterclosewiseComboBox, "CounterclosewiseComboBox=");
	strcpy(str_RotationSlider, "RotationSlider=");
	strcpy(str_DragCheckBox,"DragCheckBox=");
	strcpy(str_LiftReleaseRadioButton,"LiftReleaseRadioButton=");
	strcpy(str_TapAgainRadioButton,"TapAgainRadioButton=");
	strcpy(str_TapReleaseRadioButton,"TapReleaseRadioButton=");
	strcpy(str_DragSlider,"DragSlider=");
	strcpy(str_SwipePageCheckBox, "SwipePageCheckBox=");
	strcpy(str_FastKeyCheckBox, "FastKeyCheckBox=");
	strcpy(str_MyHomeFileCheckBox, "MyHomeFileCheckBox=");
	strcpy(str_SwitchWindowsCheckBox, "SwitchWindowsCheckBox=");
	strcpy(str_CovergestureCheckBox, "CovergestureCheckBox=");
	strcpy(str_CovergestureSlider, "CovergestureSlider=");
	strcpy(str_CovergestureComboBox, "CovergestureComboBox=");
	strcpy(str_PalmtrackingCheckBox, "PalmtrackingCheckBox=");
	strcpy(str_PalmTrackingSlider, "PalmTrackingSlider=");
#if 1
	

one_again:
	
	error_sys = system("cp ~/.elanshm ./");	
	fp0 = fopen(".elanshm","r");

	if(fp0){		
		fp1 = fopen(".elanshm_parameter","w+");		
	}

	if(fp0 == 0)
	{
		
		count++;
		if(count>=2)
			exit(1);		
		error_sys = system("elaclient2 -l > ~/.elanshm");
		goto one_again;
	}
	else 
	{
		count=0;
		do
		{
			file_over=fscanf(fp0,"%s",str);
			cmp=strcmp(str,str1);
			if(cmp != 0)
			{
			   cmp=strcmp(str,str2);
			}
			
			if((cmp != 0)&& (file_over!= -1))
			{
				fprintf(fp1,"%s",str);
				count++;
				if(count==3)
				{
				  fprintf(fp1,"\n");
				  count=0;
				}
			}
		}while(file_over != -1);
	}
	
	
	fclose(fp0);
	fclose(fp1);

	fp0 = fopen(".elanshm_parameter","r");
	

	if(fp0 == NULL)
	{
		fclose(fp0);
		return;
	}else{
		do{
			file_over=fscanf(fp0,"%s",str);
			
			/*page General*/
			str_NULL = strstr(str,str_TouchpadOff);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_TouchpadOff),"%d",&value);
				cur_elanshm.SHM_touch_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_touch
					printf( "TouchpadOff=%d \n", cur_elanshm.SHM_touch_checkBox);
				#endif 
			}
			
			str_NULL = strstr(str,str_MaxSpeed);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_MaxSpeed),"%f",&value_d);
				cur_elanshm.SHM_maxspeed_slider = value_d;
				str_NULL=NULL;
				#if debug_SHM_maxspeed
					printf( "MaxSpeed=%f \n", cur_elanshm.SHM_maxspeed_slider);
				#endif 
			}

			/*page Button*/
			str_NULL = strstr(str,str_ButtonCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ButtonCheckBox),"%d",&value);
				cur_elanshm.SHM_button_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_button_checkBox
					printf( "ButtonCheckBox=%d \n", cur_elanshm.SHM_button_checkBox);
				#endif 
			}

			str_NULL = strstr(str,str_ButtonLeftComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ButtonLeftComboBox),"%d",&value);
				cur_elanshm.SHM_button_left_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_button_left_comboBox
					printf( "ButtonLeftComboBox=%d \n", cur_elanshm.SHM_button_left_comboBox);
				#endif 
			}
	
			str_NULL = strstr(str,str_ButtonMiddleComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ButtonMiddleComboBox),"%d",&value);
				cur_elanshm.SHM_button_middle_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_button_middle_comboBox
					printf( "ButtonMiddleComboBox=%d \n", cur_elanshm.SHM_button_middle_comboBox);
				#endif 
			}

			str_NULL = strstr(str,str_ButtonRightComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ButtonRightComboBox),"%d",&value);
				cur_elanshm.SHM_button_right_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_button_right_comboBox
					printf( "ButtonRightComboBox=%d \n", cur_elanshm.SHM_button_right_comboBox);
				#endif 
			}

			/*page Tapping*/
			str_NULL = strstr(str,str_TappingCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_TappingCheckBox),"%d",&value);
				cur_elanshm.SHM_tapping_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_tapping_checkBox
					printf( "TappingCheckBox=%d \n", cur_elanshm.SHM_tapping_checkBox);
				#endif 
			}

			str_NULL = strstr(str,str_TwoFTComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_TwoFTComboBox),"%d",&value);
				cur_elanshm.SHM_two_FT_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_two_FT_comboBox
					printf( "TwoFTComboBox=%d \n", cur_elanshm.SHM_two_FT_comboBox);
				#endif 
			}

			str_NULL = strstr(str,str_ThreeFTComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ThreeFTComboBox),"%d",&value);
				cur_elanshm.SHM_three_FT_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_three_FT_comboBox
					printf( "ThreeFTComboBox=%d \n", cur_elanshm.SHM_three_FT_comboBox);
				#endif 
			}

			str_NULL = strstr(str,str_DisableWhenKeyCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_DisableWhenKeyCheckBox),"%d",&value);
				cur_elanshm.SHM_disable_when_key_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_disable_when_key_checkBox
					printf( "DisableWhenKeyCheckBox=%d \n", cur_elanshm.SHM_disable_when_key_checkBox);
				#endif 
			}

			str_NULL = strstr(str,str_TappingDelayComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_TappingDelayComboBox),"%d",&value);
				cur_elanshm.SHM_tapping_delay_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_tapping_delay_comboBox
					printf( "TappingDelayComboBox=%d \n", cur_elanshm.SHM_tapping_delay_comboBox);
				#endif 
			}

			str_NULL = strstr(str,str_CursorDelayComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_CursorDelayComboBox),"%d",&value);
				cur_elanshm.SHM_cursor_delay_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_cursor_delay_comboBox
					printf( "CursorDelayComboBox=%d \n", cur_elanshm.SHM_cursor_delay_comboBox);
				#endif 
			}

			str_NULL = strstr(str,str_GestureDelayComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_GestureDelayComboBox),"%d",&value);
				cur_elanshm.SHM_gesture_delay_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_gesture_delay_comboBox
					printf( "GestureDelayComboBox=%d \n", cur_elanshm.SHM_gesture_delay_comboBox);
				#endif 
			}

			str_NULL = strstr(str,str_CoverDelayComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_CoverDelayComboBox),"%d",&value);
				cur_elanshm.SHM_cover_delay_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_cover_delay_comboBox
					printf( "CoverDelayComboBox=%d \n", cur_elanshm.SHM_cover_delay_comboBox);
				#endif 
			}

			str_NULL = strstr(str,str_PalmtrackDelayComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_PalmtrackDelayComboBox),"%d",&value);
				cur_elanshm.SHM_palmtrack_delay_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_palmtrack_delay_comboBox
					printf( "PalmtrackDelayComboBox=%d \n", cur_elanshm.SHM_palmtrack_delay_comboBox);
				#endif 
			}

			 /*page Edgo Scrolling*/
			str_NULL = strstr(str,str_EdgeVscrollCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_EdgeVscrollCheckBox),"%d",&value);
				cur_elanshm.SHM_edge_v_scroll_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_edge_v_scroll_checkBox
					printf( "EdgeVscrollCheckBox=%d \n", cur_elanshm.SHM_edge_v_scroll_checkBox);
				#endif 
			}

			str_NULL = strstr(str,str_EdgeHscrollCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_EdgeHscrollCheckBox),"%d",&value);
				cur_elanshm.SHM_edge_h_scroll_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_edge_h_scroll_checkBox
					printf( "EdgeHscrollCheckBox=%d \n", cur_elanshm.SHM_edge_h_scroll_checkBox);
				#endif 
			}
			
			str_NULL = strstr(str,str_EdgeScrollSpeedSlider);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_EdgeScrollSpeedSlider),"%d",&value);
				cur_elanshm.SHM_edge_scroll_speed_slider = value;
				str_NULL=NULL;
				#if debug_SHM_edge_scroll_speed_slider
					printf( "EdgeScrollSpeedSlider=%d \n", cur_elanshm.SHM_edge_scroll_speed_slider);
				#endif 
			}
			str_NULL = strstr(str,str_EdgeScrollAreaSlider);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_EdgeScrollAreaSlider),"%d",&value);
				cur_elanshm.SHM_edge_scroll_area_slider = value;
				str_NULL=NULL;
				#if debug_SHM_edge_scroll_area_slider
					printf( "EdgeScrollAreaSlider=%d \n", cur_elanshm.SHM_edge_scroll_area_slider);
				#endif 
			}
			
			/*page Scrolling*/
			str_NULL = strstr(str,str_VerticalScrollingCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_VerticalScrollingCheckBox),"%d",&value);
				cur_elanshm.SHM_vertical_scrolling_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_vertical_scrolling_checkBox
					printf( "VerticalScrollingCheckBox=%d \n", cur_elanshm.SHM_vertical_scrolling_checkBox);
				#endif 
			}

			str_NULL = strstr(str,str_HorizontalScrollingCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_HorizontalScrollingCheckBox),"%d",&value);
				cur_elanshm.SHM_horizontal_scrolling_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_horizontal_scrolling_checkBox
					printf( "HorizontalScrollingCheckBox=%d \n", cur_elanshm.SHM_horizontal_scrolling_checkBox);
				#endif 
			}

			str_NULL = strstr(str,str_ScrollingSpeedSlider);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ScrollingSpeedSlider),"%d",&value);
				cur_elanshm.SHM_scrolling_speed_slider = value;
				str_NULL=NULL;
				#if debug_SHM_scrolling_speed_slider
					printf( "ScrollingSpeedSlider=%d \n", cur_elanshm.SHM_scrolling_speed_slider);
				#endif 
			}

			str_NULL = strstr(str,str_AutoScrollCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_AutoScrollCheckBox),"%d",&value);
				cur_elanshm.SHM_auto_scroll_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_auto_scroll_checkBox
					printf( "AutoScrollCheckBox=%d \n", cur_elanshm.SHM_auto_scroll_checkBox);
				#endif 
			}

			/*page Zoom*/
			str_NULL = strstr(str,str_ZoomCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ZoomCheckBox),"%d",&value);
				cur_elanshm.SHM_zoom_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_zoom_checkBox
					printf( "ZoomCheckBox=%d \n", cur_elanshm.SHM_zoom_checkBox);
				#endif 
			}
			
			str_NULL = strstr(str,str_ZoomOutComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ZoomOutComboBox),"%d",&value);
				cur_elanshm.SHM_zoom_out_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_zoom_out_comboBox
					printf( "ZoomOutComboBox=%d \n", cur_elanshm.SHM_zoom_out_comboBox);
				#endif 
			}
			
			str_NULL = strstr(str,str_ZoomInComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ZoomInComboBox),"%d",&value);
				cur_elanshm.SHM_zoom_in_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_zoom_in_comboBox
					printf( "ZoomInComboBox=%d \n", cur_elanshm.SHM_zoom_in_comboBox);
				#endif 
			}

			str_NULL = strstr(str,str_ZoomSlider);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ZoomSlider),"%d",&value);
				cur_elanshm.SHM_zoom_slider = value;
				str_NULL=NULL;
				#if debug_SHM_zoom_slider
					printf( "ZoomSlider=%d \n", cur_elanshm.SHM_zoom_slider);
				#endif 
			}

			/*page Rotation*/
			str_NULL = strstr(str,str_RotationCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_RotationCheckBox),"%d",&value);
				cur_elanshm.SHM_rotation_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_rotation_checkBox
					printf( "RotationCheckBox=%d \n", cur_elanshm.SHM_rotation_checkBox);
				#endif 
			}

			
			str_NULL = strstr(str,str_ClockwiseComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ClockwiseComboBox),"%d",&value);
				cur_elanshm.SHM_clockwise_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_clockwise_comboBox
					printf( "ClockwiseComboBox=%d \n", cur_elanshm.SHM_clockwise_comboBox);
				#endif 
			}

			str_NULL = strstr(str,str_CounterclosewiseComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_CounterclosewiseComboBox),"%d",&value);
				cur_elanshm.SHM_counterclosewise_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_counterclosewise_comboBox
					printf( "CounterclosewiseComboBox=%d \n", cur_elanshm.SHM_counterclosewise_comboBox);
				#endif 
			}

			str_NULL = strstr(str,str_RotationSlider);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_RotationSlider),"%d",&value);
				cur_elanshm.SHM_rotation_slider = value;
				str_NULL=NULL;
				#if debug_SHM_rotation_slider
					printf( "CounterclosewiseComboBox=%d \n", cur_elanshm.SHM_rotation_slider);
				#endif 
			}
			/*page Drag*/
			str_NULL = strstr(str,str_DragCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_DragCheckBox),"%d",&value);
				cur_elanshm.SHM_drag_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_drag_checkBox
					printf( "DragCheckBox=%d \n", cur_elanshm.SHM_drag_checkBox);
				#endif 
			}

			str_NULL = strstr(str,str_LiftReleaseRadioButton);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_LiftReleaseRadioButton),"%d",&value);
				cur_elanshm.SHM_lift_release_radioButton = value;
				str_NULL=NULL;
				#if debug_SHM_lift_release_radioButton
					printf( "LiftReleaseRadioButton=%d \n", cur_elanshm.SHM_lift_release_radioButton);
				#endif 
			}

			str_NULL = strstr(str,str_TapAgainRadioButton);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_TapAgainRadioButton),"%d",&value);
				cur_elanshm.SHM_tap_again_radioButton = value;
				str_NULL=NULL;
				#if debug_SHM_tap_again_radioButton
					printf( "TapAgainRadioButton=%d \n", cur_elanshm.SHM_tap_again_radioButton);
				#endif 
			}
	
			str_NULL = strstr(str,str_TapReleaseRadioButton);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_TapReleaseRadioButton),"%d",&value);
				cur_elanshm.SHM_tap_release_radioButton = value;
				str_NULL=NULL;
				#if debug_SHM_tap_release_radioButton
					printf( "TapReleaseRadioButton=%d \n", cur_elanshm.SHM_tap_release_radioButton);
				#endif 
			}

			str_NULL = strstr(str,str_DragSlider);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_DragSlider),"%f",&value_d);
				cur_elanshm.SHM_drag_slider = value_d;
				str_NULL=NULL;
				#if debug_SHM_drag_slider
					printf( "DragSlider=%f \n", cur_elanshm.SHM_drag_slider);
				#endif 
			}
			/*page Swipe*/
			str_NULL = strstr(str,str_SwipePageCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_SwipePageCheckBox),"%d",&value);
				cur_elanshm.SHM_swipe_page_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_swipe_page_checkBox
					printf( "SwipePageCheckBox=%d \n", cur_elanshm.SHM_swipe_page_checkBox);
				#endif 
			}

			/*page Fast_keys*/
			str_NULL = strstr(str,str_FastKeyCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_FastKeyCheckBox),"%d",&value);
				cur_elanshm.SHM_fast_key_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_fast_key_checkBox
					printf( "FastKeyCheckBox=%d \n", cur_elanshm.SHM_fast_key_checkBox);
				#endif 
			}
			
			str_NULL = strstr(str,str_MyHomeFileCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_MyHomeFileCheckBox),"%d",&value);
				cur_elanshm.SHM_my_home_file_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_my_home_file_checkBox
					printf( "MyHomeFileCheckBox=%d \n", cur_elanshm.SHM_my_home_file_checkBox);
				#endif 
			}

			str_NULL = strstr(str,str_SwitchWindowsCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_SwitchWindowsCheckBox),"%d",&value);
				cur_elanshm.SHM_switch_windows_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_switch_windows_checkBox
					printf( "SwitchWindowsCheckBox=%d \n", cur_elanshm.SHM_switch_windows_checkBox);
				#endif 
			}

			/*page Covergesture*/
			str_NULL = strstr(str,str_CovergestureCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_CovergestureCheckBox),"%d",&value);
				cur_elanshm.SHM_covergesture_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_covergesture_checkBox
					printf( "CovergestureCheckBox=%d \n", cur_elanshm.SHM_covergesture_checkBox);
				#endif 
			}

			str_NULL = strstr(str,str_CovergestureSlider);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_CovergestureSlider),"%d",&value);
				cur_elanshm.SHM_covergesture_slider = value;
				str_NULL=NULL;
				#if debug_SHM_covergesture_slider
					printf( "CovergestureSlider=%d \n", cur_elanshm.SHM_covergesture_slider);
				#endif 
			}
			
			str_NULL = strstr(str,str_CovergestureComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_CovergestureComboBox),"%d",&value);
				cur_elanshm.SHM_covergesture_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_covergesture_comboBox
					printf( "CovergestureComboBox=%d \n", cur_elanshm.SHM_covergesture_comboBox);
				#endif 
			}
			
			
			str_NULL = strstr(str,str_PalmtrackingCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_PalmtrackingCheckBox),"%d",&value);
				cur_elanshm.SHM_palmtracking_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_palmtracking_checkBox
					printf( "PalmtrackingCheckBox=%d \n", cur_elanshm.SHM_palmtracking_checkBox);
				#endif 
			}
		
			str_NULL = strstr(str,str_PalmTrackingSlider);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_PalmTrackingSlider),"%d",&value);
				cur_elanshm.SHM_palmtracking_slider = value;
				str_NULL=NULL;
				#if debug_SHM_palmtracking_slider
					printf( "PalmTrackingSlider=%d \n", cur_elanshm.SHM_palmtracking_slider);
				#endif 
			}
		}while(file_over != -1);
		
	}
	

	fclose(fp0);
#endif	

	/*page General*/	
	sprintf(command,"elaclient2 TouchpadOff=%d ",cur_elanshm.SHM_touch_checkBox);
	error_sys = system(command);
	#if debug_SHM_touch
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2 MaxSpeed=%g ",cur_elanshm.SHM_maxspeed_slider);
	error_sys = system(command);
	#if debug_SHM_maxspeed
	printf("%s\n",command);
	#endif

	/*page Button*/
	sprintf(command,"elaclient2 ButtonCheckBox=%d ",cur_elanshm.SHM_button_checkBox);
	error_sys = system(command);
	#if debug_SHM_button_checkBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2 ButtonLeftComboBox=%d ",cur_elanshm.SHM_button_left_comboBox);
	error_sys = system(command);
	#if debug_SHM_button_left_comboBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2 ButtonMiddleComboBox=%d ",cur_elanshm.SHM_button_middle_comboBox);
	error_sys = system(command);
	#if debug_SHM_button_middle_comboBox
	printf("%s\n",command);
	#endif
	
	sprintf(command,"elaclient2 ButtonRightComboBox=%d ",cur_elanshm.SHM_button_right_comboBox);
	error_sys = system(command);
	#if debug_SHM_button_right_comboBox
	printf("%s\n",command);
	#endif

	/*page Tapping*/
	sprintf(command,"elaclient2 TappingCheckBox=%d ",cur_elanshm.SHM_tapping_checkBox);
	error_sys = system(command);
	#if debug_SHM_tapping_checkBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2 TwoFTComboBox=%d ",cur_elanshm.SHM_two_FT_comboBox);
	error_sys = system(command);
	#if debug_SHM_two_FT_comboBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2 ThreeFTComboBox=%d ",cur_elanshm.SHM_three_FT_comboBox);
	error_sys = system(command);
	#if debug_SHM_three_FT_comboBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2 DisableWhenKeyCheckBox=%d ",cur_elanshm.SHM_disable_when_key_checkBox);
	error_sys = system(command);
	#if debug_SHM_disable_when_key_checkBox
	printf("%s\n",command);
	#endif
	
	sprintf(command,"elaclient2  TappingDelayComboBox=%d",cur_elanshm.SHM_tapping_delay_comboBox);
	error_sys = system(command);
	#if debug_SHM_tapping_delay_comboBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2  CursorDelayComboBox=%d",cur_elanshm.SHM_cursor_delay_comboBox);
	error_sys = system(command);
	#if debug_SHM_cursor_delay_comboBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2  GestureDelayComboBox=%d",cur_elanshm.SHM_gesture_delay_comboBox);
	error_sys = system(command);
	#if debug_SHM_gesture_delay_comboBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2  CoverDelayComboBox=%d",cur_elanshm.SHM_cover_delay_comboBox);
	error_sys = system(command);
	#if debug_SHM_cover_delay_comboBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2  PalmtrackDelayComboBox=%d",cur_elanshm.SHM_palmtrack_delay_comboBox);
	error_sys = system(command);
	#if debug_SHM_palmtrack_delay_comboBox
	printf("%s\n",command);
	#endif
	/*page Edgo Scrolling*/
	sprintf(command,"elaclient2  EdgeVscrollCheckBox=%d",cur_elanshm.SHM_edge_v_scroll_checkBox);
	error_sys = system(command);
	#if debug_SHM_edge_v_scroll_checkBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2  EdgeHscrollCheckBox=%d",cur_elanshm.SHM_edge_h_scroll_checkBox);
	error_sys = system(command);
	#if debug_SHM_edge_h_scroll_checkBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2  EdgeScrollSpeedSlider=%d",cur_elanshm.SHM_edge_scroll_speed_slider);
	error_sys = system(command);
	#if debug_SHM_edge_scroll_speed_slider
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2  EdgeScrollAreaSlider=%d",cur_elanshm.SHM_edge_scroll_area_slider);
	error_sys = system(command);
	#if debug_SHM_edge_scroll_area_slider
	printf("%s\n",command);
	#endif

	/*page Scrolling*/
	sprintf(command,"elaclient2 VerticalScrollingCheckBox=%d ",cur_elanshm.SHM_vertical_scrolling_checkBox);
	error_sys = system(command);
	#if debug_SHM_vertical_scrolling_checkBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2 HorizontalScrollingCheckBox=%d ",cur_elanshm.SHM_horizontal_scrolling_checkBox);
	error_sys = system(command);
	#if debug_SHM_horizontal_scrolling_checkBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2 ScrollingSpeedSlider=%d ",cur_elanshm.SHM_scrolling_speed_slider);
	error_sys = system(command);
	#if debug_SHM_scrolling_speed_slider
	printf("%s\n",command);
	#endif

	

	sprintf(command,"elaclient2 AutoScrollCheckBox=%d ",cur_elanshm.SHM_auto_scroll_checkBox);
	error_sys = system(command);
	#if debug_SHM_auto_scroll_checkBox
	printf("%s\n",command);
	#endif

	/*page Zoom*/
	sprintf(command,"elaclient2 ZoomCheckBox=%d ",cur_elanshm.SHM_zoom_checkBox);
	error_sys = system(command);
	#if debug_SHM_zoom_checkBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2 ZoomOutComboBox=%d ",cur_elanshm.SHM_zoom_out_comboBox);
	error_sys = system(command);
	#if debug_SHM_zoom_out_comboBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2 ZoomInComboBox=%d ",cur_elanshm.SHM_zoom_in_comboBox);
	error_sys = system(command);
	#if debug_SHM_zoom_in_comboBox
	printf("%s\n",command);
	#endif
	
	sprintf(command,"elaclient2 ZoomSlider=%d ",cur_elanshm.SHM_zoom_slider);
	error_sys = system(command);
	#if debug_SHM_zoom_slider
	printf("%s\n",command);
	#endif

	/*page Rotation*/
	sprintf(command,"elaclient2 RotationCheckBox=%d ",cur_elanshm.SHM_rotation_checkBox);
	error_sys = system(command);
	#if debug_SHM_rotation_checkBox
	printf("%s\n",command);
	#endif
	
	sprintf(command,"elaclient2 ClockwiseComboBox=%d ",cur_elanshm.SHM_clockwise_comboBox);
	error_sys = system(command);
	#if debug_SHM_clockwise_comboBox
	printf("%s\n",command);
	#endif
	
	sprintf(command,"elaclient2 CounterclosewiseComboBox=%d ",cur_elanshm.SHM_counterclosewise_comboBox);
	error_sys = system(command);
	#if debug_SHM_counterclosewise_comboBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2 RotationSlider=%d ",cur_elanshm.SHM_rotation_slider);
	error_sys = system(command);
	#if debug_SHM_rotation_slider
	printf("%s\n",command);
	#endif

	/*page Drag*/
	sprintf(command,"elaclient2 DragCheckBox=%d ",cur_elanshm.SHM_drag_checkBox);
	error_sys = system(command);
	#if debug_SHM_drag_checkBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2 LiftReleaseRadioButton=%d ",cur_elanshm.SHM_lift_release_radioButton);
	error_sys = system(command);
	#if debug_SHM_lift_release_radioButton
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2 TapAgainRadioButton=%d ",cur_elanshm.SHM_tap_again_radioButton);
	error_sys = system(command);
	#if debug_SHM_tap_again_radioButton
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2 TapReleaseRadioButton=%d ",cur_elanshm.SHM_tap_release_radioButton);
	error_sys = system(command);
	#if debug_SHM_tap_release_radioButton
	printf("%s\n",command);
	#endif
	
	sprintf(command,"elaclient2 DragSlider=%g ",cur_elanshm.SHM_drag_slider);
	error_sys = system(command);
	#if debug_SHM_drag_slider
	printf("%s\n",command);
	#endif

	/*page Swipe*/
	sprintf(command,"elaclient2 SwipePageCheckBox=%d ",cur_elanshm.SHM_swipe_page_checkBox);
	error_sys = system(command);
	#if debug_SHM_swipe_page_checkBox
	printf("%s\n",command);
	#endif

	/*page Fast_keys*/
	sprintf(command,"elaclient2 FastKeyCheckBox=%d ",cur_elanshm.SHM_fast_key_checkBox);
	error_sys = system(command);
	#if debug_SHM_fast_key_checkBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2 MyHomeFileCheckBox=%d ",cur_elanshm.SHM_my_home_file_checkBox);
	error_sys = system(command);
	#if debug_SHM_my_home_file_checkBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2 SwitchWindowsCheckBox=%d ",cur_elanshm.SHM_switch_windows_checkBox);
	error_sys = system(command);
	#if debug_SHM_switch_windows_checkBox
	printf("%s\n",command);
	#endif

	/*page Covergesture*/
	sprintf(command,"elaclient2 CovergestureCheckBox=%d ",cur_elanshm.SHM_covergesture_checkBox);
	error_sys = system(command);
	#if debug_SHM_covergesture_checkBox
	printf("%s\n",command);
	#endif

	sprintf(command,"elaclient2 CovergestureSlider=%d ",cur_elanshm.SHM_covergesture_slider);
	error_sys = system(command);
	#if debug_SHM_covergesture_slider
	printf("%s\n",command);
	#endif
	
	sprintf(command,"elaclient2 CovergestureComboBox=%d ",cur_elanshm.SHM_covergesture_comboBox);
	error_sys = system(command);
	#if debug_SHM_covergesture_comboBox
	printf("%s\n",command);
	#endif	

	/*page PalmTracking*/
	sprintf(command,"elaclient2 PalmtrackingCheckBox=%d ",cur_elanshm.SHM_palmtracking_checkBox);
	error_sys = system(command);
	#if debug_SHM_palmtracking_checkBox
	printf("%s\n",command);
	#endif
	
	sprintf(command,"elaclient2 PalmTrackingSlider=%d ",cur_elanshm.SHM_palmtracking_slider);
	error_sys = system(command);
	#if debug_SHM_palmtracking_slider
	printf("%s\n",command);
	#endif
#if 0
	free(str1);
	printf("steup1-1\n");
	free(str2);
	printf("steup1-2\n");
	free(str_TouchpadOff);
	printf("steup1-str_TouchpadOff\n");
	free(str_MaxSpeed);
	printf("steup1-str_MaxSpeed\n");
	free(str_ButtonCheckBox);
	printf("steup1-str_ButtonCheckBox\n");	
	free(str_ButtonLeftComboBox);
	printf("steup1-str_ButtonLeftComboBox\n");
	free(str_ButtonMiddleComboBox);
	printf("steup1-str_ButtonMiddleComboBox\n");
	free(str_ButtonRightComboBox);
	printf("steup1-str_ButtonRightComboBox\n");	
	free(str_TappingCheckBox);
	printf("steup1-str_TappingCheckBox\n");
	free(str_TwoFTComboBox);
	printf("steup1-str_TwoFTComboBox\n");
	free(str_ThreeFTComboBox);
	printf("steup1-str_ThreeFTComboBox\n");
	free(str_DisableWhenKeyCheckBox);
	printf("steup1-str_DisableWhenKeyCheckBox\n");
	free(str_TappingDelayComboBox);
	printf("steup1-str_TappingDelayComboBox\n");
	free(str_CursorDelayComboBox);
	printf("steup1-str_CursorDelayComboBox\n");
	free(str_GestureDelayComboBox);
	printf("steup1-str_GestureDelayComboBox\n");
	free(str_PalmtrackDelayComboBox);
	printf("steup1-str_PalmtrackDelayComboBox\n");
	free(str_EdgeVscrollCheckBox);
	printf("steup1-str_EdgeVscrollCheckBox\n");
	free(str_EdgeHscrollCheckBox);
	printf("steup1-str_EdgeHscrollCheckBox\n");
	free(str_EdgeScrollSpeedSlider);
	printf("steup1-str_EdgeScrollSpeedSlider\n");
	free(str_EdgeScrollAreaSlider);
	printf("steup1-str_EdgeScrollAreaSlider\n"); 
	free(str_VerticalScrollingCheckBox);
	printf("steup1-str_VerticalScrollingCheckBox\n");
	free(str_HorizontalScrollingCheckBox);
	printf("steup1-str_HorizontalScrollingCheckBox\n");
	free(str_ScrollingSpeedSlider);
	printf("steup1-str_ScrollingSpeedSlider\n");
	free(str_AutoScrollCheckBox);
	printf("steup1-str_AutoScrollCheckBox\n");	
	free(str_ZoomCheckBox);
	printf("steup1-str_ZoomCheckBox8\n");
	free(str_ZoomOutComboBox);
	printf("steup1-str_ZoomOutComboBox\n");
	free(str_ZoomInComboBox);
	printf("steup1-str_ZoomInComboBox\n");
	free(str_ZoomSlider);
	printf("steup1-str_ZoomSlider\n");
	free(str_RotationCheckBox);
	printf("steup1-str_RotationCheckBox\n");
	free(str_ClockwiseComboBox);
	printf("steup1-str_ClockwiseComboBox\n");
	free(str_CounterclosewiseComboBox);
	printf("steup1-str_CounterclosewiseComboBox\n");
	free(str_RotationSlider);
	printf("steup1-str_RotationSlider\n");
	free(str_DragCheckBox);
	printf("steup1-str_DragCheckBox\n");
	free(str_LiftReleaseRadioButton);
	printf("steup1-str_LiftReleaseRadioButton\n");
	free(str_TapAgainRadioButton);
	printf("steup1-str_TapAgainRadioButton\n");
	free(str_TapReleaseRadioButton);
	printf("steup1-str_TapReleaseRadioButton\n");
	free(str_DragSlider);
	printf("steup1-str_DragSlider\n");
	free(str_SwipePageCheckBox);
	printf("steup1-str_SwipePageCheckBox\n");
	free(str_FastKeyCheckBox);
	printf("steup1-str_FastKeyCheckBox\n");
	free(str_MyHomeFileCheckBox);
	printf("steup1-str_MyHomeFileCheckBox\n");
	free(str_SwitchWindowsCheckBox);
	printf("steup1-str_SwitchWindowsCheckBox\n");
	free(str_CovergestureCheckBox);
	printf("steup1-str_CovergestureCheckBox\n");
	free(str_CovergestureSlider);
	printf("steup1-str_CovergestureSlider\n");	
	free(str_CovergestureComboBox);
	printf("steup1-str_CovergestureComboBox\n");	
	free(str_PalmtrackingCheckBox);
	printf("steup1-str_PalmtrackingCheckBox\n");
	free(str_PalmTrackingSlider);
	printf("steup1-str_PalmTrackingSlider\n");
#else
	free(str1);
	free(str2);
	free(str_TouchpadOff);
	free(str_MaxSpeed);
	free(str_ButtonCheckBox);	
	free(str_ButtonLeftComboBox);
	free(str_ButtonMiddleComboBox);
	free(str_ButtonRightComboBox);
	free(str_TappingCheckBox);
	free(str_TwoFTComboBox);
	free(str_ThreeFTComboBox);
	free(str_DisableWhenKeyCheckBox);
	free(str_TappingDelayComboBox);
	free(str_CursorDelayComboBox);
	free(str_GestureDelayComboBox);
	free(str_PalmtrackDelayComboBox);
	free(str_EdgeVscrollCheckBox);
	free(str_EdgeHscrollCheckBox);
	free(str_EdgeScrollSpeedSlider);
	free(str_EdgeScrollAreaSlider);
	free(str_VerticalScrollingCheckBox);
	free(str_HorizontalScrollingCheckBox);
	free(str_ScrollingSpeedSlider);
	free(str_AutoScrollCheckBox);	
	free(str_ZoomCheckBox);
	free(str_ZoomOutComboBox);
	free(str_ZoomInComboBox);
	free(str_ZoomSlider);
	free(str_RotationCheckBox);
	free(str_ClockwiseComboBox);
	free(str_CounterclosewiseComboBox);
	free(str_RotationSlider);
	free(str_DragCheckBox);
	free(str_LiftReleaseRadioButton);
	free(str_TapAgainRadioButton);
	free(str_TapReleaseRadioButton);
	free(str_DragSlider);
	free(str_SwipePageCheckBox);
	free(str_FastKeyCheckBox);
	free(str_MyHomeFileCheckBox);
	free(str_SwitchWindowsCheckBox);
	free(str_CovergestureCheckBox);	
	free(str_CovergestureSlider);		
	free(str_CovergestureComboBox);
	free(str_PalmtrackingCheckBox);	
	free(str_PalmTrackingSlider);
	
#endif
	return;
	


}
