#ifndef _HOTKEY_THREAD_H__
#define	_HOTKEY_THREAD_H__

#include <unistd.h>
#include <X11/Xlib.h>
#include <X11/extensions/XTest.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <wchar.h>
#include <locale.h>



#define debug_hotkey 0

typedef enum{
	Click_Select=0,
	Pop_up_Menu,
	Middle_Button,
	Internet_Forward,
	Internet_Back,
	Max_Window,
	Min_Window,
	None_Event,
	Page_Down,
	Page_Up,
	Scroll_Down,
	Scroll_Left,
	Scroll_Right,
	Scroll_Up,
	Zoom_Out,
	Zoom_In,	
	Close_Window,
	Return_To_DeskTop
}minorComb1;

typedef enum{	
	PAGE_Up=0,
	PAGE_Down,
	ZOOM_Out,
	ZOOM_In,
	MIN_Window,
	MAX_Window
}minorComb2;

typedef enum{	
	ROTATION_Right=2,
	ROTATION_Left,	
}minorComb3;

typedef enum{
	Button_Left= 0,		//0
	Button_Middle,		//1
	Button_Right,		//2
	Tapping_TwoFingers,	//3
	Tapping_ThreeFingers,	//4
	Scroll_up,		//5
	Scroll_down,		//6
	Scroll_left,		//7
	Scroll_right,		//8
	Zoom_out,		//9
	Zoom_in,		//10
	Rotation_right,		//11
	Rotation_left,		//12
	ThreeFinger_Left,	//13
	ThreeFinger_Right,	//14
	ThreeFinger_Up,		//15
	ThreeFinger_Down_down,	//16
	ThreeFinger_Down_left,  //17
	ThreeFinger_Down_right, //18 
	ThreeFinger_Down_up,    //19
	Covergusture_hand,	//20
	OnefingerTapping,   	//21
	DRAG_RELEASE,		//22
	DRAG_CLASS,		//23
}FunEvent;
	
typedef enum{
	Key=0,
	KeyDown,
	KeyUp,
	String,
	MouseClick,
	MouseDown,
	MouseUp,
}HotKey;


extern void *hotkey_thread(void *arg);

int Rotation_r_image_flag;
int Rotation_l_image_flag;
int Zoom_in_image_flag;
int Zoom_out_image_flag;
int Scrool_V_image_flag;
int Scrool_H_image_flag;


#endif