/*   Elantech Passthrough Support
 *   Copyright (c) 2008 Elantech Inc Tom Lin<tom_lin@elantech.com.tw>
 *   Copyring  (c) 2009 ELAN Inc Tom Lin<tom_lin@emc.com.tw>
 *   					   Roger Chaung <roger_chaung@emc.com.tw>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 * Trademarks are the property of their respective owners.
 *
 */
#ifndef ELANTRAYICON_H_
#define ELANTRAYICON_H_

#include <QApplication>
#include <QSystemTrayIcon>
#include <QMenu>
#include <QtGui>
#include <QTextStream>
#include <QTranslator>


#include <iostream>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>

#define ELAN_VERSION "ETD7.1.4 Free"


class QElanTrayicon : public QObject
{
	Q_OBJECT

private:
	QSystemTrayIcon	*trayIcon;	
	void createActions();
	void createTrayIconMenu();
	QAction *property_of_smart_pad;
	QMenu *trayIconMenu;
	
public slots:
	void   slot_iconActivated(QSystemTrayIcon::ActivationReason reason);//TOM +
	void   slot_property_of_smart_pad();
public:
	QElanTrayicon();
};

#endif
